-- 22/12/2020 MARCO BALESTRI
-- CATALOG FUNCTION TABLES UPDATE

-- START

-- CLEAN OLD TABLES
DELETE FROM SBI_CATALOG_FUNCTION;
DELETE FROM SBI_FUNCTION_INPUT_VARIABLE;

-- DROP OLD TABLES
DROP TABLE IF EXISTS SBI_FUNCTION_OUTPUT, SBI_FUNCTION_INPUT_DATASET, SBI_FUNCTION_INPUT_FILE;

-- ------------------------- TABLE SBI_CATALOG_FUNCTION -------------------------
ALTER TABLE SBI_CATALOG_FUNCTION
ADD COLUMN BENCHMARKS TEXT,
ADD COLUMN FAMILY TEXT,
ADD COLUMN ONLINE_SCRIPT TEXT,
ADD COLUMN OFFLINE_SCRIPT_TRAIN TEXT,
ADD COLUMN OFFLINE_SCRIPT_USE TEXT,
DROP COLUMN SCRIPT,
DROP COLUMN URL,
DROP COLUMN REMOTE;

-- ----------------------- TABLE SBI_FUNCTION_INPUT_COLUMN -----------------------
CREATE TABLE IF NOT EXISTS SBI_FUNCTION_INPUT_COLUMN (LIKE SBI_FUNCTION_INPUT_VARIABLE);

ALTER TABLE SBI_FUNCTION_INPUT_COLUMN
ALTER COLUMN VAR_NAME TYPE VARCHAR(100),
ALTER COLUMN VAR_VALUE TYPE VARCHAR(100);


ALTER TABLE SBI_FUNCTION_INPUT_COLUMN
RENAME COLUMN VAR_NAME TO COL_NAME;

ALTER TABLE SBI_FUNCTION_INPUT_COLUMN
RENAME COLUMN VAR_VALUE TO COL_TYPE;

-- ---------------------- TABLE SBI_FUNCTION_INPUT_VARIABLE ---------------------
ALTER TABLE SBI_FUNCTION_INPUT_VARIABLE
ADD COLUMN VAR_TYPE VARCHAR(100);

-- ---------------------- TABLE SBI_FUNCTION_OUTPUT_COLUMN -----------------------
CREATE TABLE IF NOT EXISTS SBI_FUNCTION_OUTPUT_COLUMN (LIKE SBI_FUNCTION_INPUT_COLUMN);

ALTER TABLE SBI_FUNCTION_OUTPUT_COLUMN
ADD COLUMN COL_FIELD_TYPE VARCHAR(100);

-- --------------------------- TABLE SBI_OBJ_FUNCTION ---------------------------
CREATE TABLE IF NOT EXISTS SBI_OBJ_FUNCTION (LIKE SBI_OBJ_DATA_SET);

ALTER TABLE SBI_OBJ_FUNCTION
DROP IS_DETAIL;

ALTER TABLE SBI_OBJ_FUNCTION
ALTER COLUMN BIOBJ_DS_ID TYPE INT,
ALTER COLUMN DS_ID TYPE INT;

ALTER TABLE SBI_OBJ_FUNCTION
RENAME COLUMN BIOBJ_DS_ID TO BIOBJ_FUNCTION_ID;

ALTER TABLE SBI_OBJ_FUNCTION
RENAME COLUMN  DS_ID TO FUNCTION_ID;

ALTER TABLE SBI_OBJ_FUNCTION
ADD FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS(BIOBJ_ID),
ADD FOREIGN KEY (FUNCTION_ID) REFERENCES SBI_CATALOG_FUNCTION(FUNCTION_ID);

-- END

-- 15/02/2021 - Cockpit complexity initializer
CREATE TABLE SBI_COCKPIT_ASSOCIATION (
	SBI_COCKPIT_ASSOCIATION_ID INT4 NOT NULL,
	BIOBJ_ID INT4 NULL,
	DS_ID_FROM INT4 NULL,
	COLUMN_NAME_FROM VARCHAR NULL,
	DS_ID_TO INT4 NULL,
	COLUMN_NAME_TO VARCHAR NULL,
	USER_IN VARCHAR(100) NOT NULL,
	USER_UP VARCHAR(100) NULL,
	USER_DE VARCHAR(100) NULL,
	TIME_IN TIMESTAMP NOT NULL,
	TIME_UP TIMESTAMP NULL,
	TIME_DE TIMESTAMP NULL,
	SBI_VERSION_IN VARCHAR(10) NULL,
	SBI_VERSION_UP VARCHAR(10) NULL,
	SBI_VERSION_DE VARCHAR(10) NULL,
	META_VERSION VARCHAR(100) NULL,
	ORGANIZATION VARCHAR(20) NULL,
	CONSTRAINT SBI_COCKPIT_ASSOCIATION_PK PRIMARY KEY (SBI_COCKPIT_ASSOCIATION_ID),
	CONSTRAINT SBI_COCKPIT_ASSOCIATION_FK FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS(BIOBJ_ID) ON DELETE CASCADE
);

CREATE TABLE SBI_COCKPIT_WIDGET (
	SBI_COCKPIT_WIDGET_ID INT4 NOT NULL,
	BIOBJ_ID INT4 NULL,
	TAB VARCHAR NULL,
	WIDGET_TYPE VARCHAR NULL,
	DS_ID INT4 NULL,
	ASSOCIATIVE BOOL NULL,
	"cache" BOOL NULL,
	FILTERS BOOL NULL,
	USER_IN VARCHAR(100) NOT NULL,
	USER_UP VARCHAR(100) NULL,
	USER_DE VARCHAR(100) NULL,
	TIME_IN TIMESTAMP NOT NULL,
	TIME_UP TIMESTAMP NULL,
	TIME_DE TIMESTAMP NULL,
	SBI_VERSION_IN VARCHAR(10) NULL,
	SBI_VERSION_UP VARCHAR(10) NULL,
	SBI_VERSION_DE VARCHAR(10) NULL,
	META_VERSION VARCHAR(100) NULL,
	ORGANIZATION VARCHAR(20) NULL,
	CONSTRAINT SBI_COCKPIT_WIDGET_PK PRIMARY KEY (SBI_COCKPIT_WIDGET_ID),
	CONSTRAINT SBI_COCKPIT_WIDGET_FK FOREIGN KEY (BIOBJ_ID) REFERENCES SBI_OBJECTS(BIOBJ_ID) ON DELETE CASCADE
);

-- 15/03/2021 - Updated the parameter region to "east"
UPDATE SBI_OBJECTS SET PARAMETERS_REGION='east';